// this sets the background color of the master UIView (when there are no windows/tab groups on it)

var isAppFile = 1;
Titanium.include("lib/defaults.js", "lib/profile.js");

Titanium.UI.setBackgroundColor('#000');

// create tab group
var tabGroup = Titanium.UI.createTabGroup();




//
// create base UI tab and root window
//

var defWinSettings = {
    barColor: '#444',
    backgroundColor: '#EAEAEA'
};

var win1 = Titanium.UI.createWindow({
    title: 'HoroshoTV',
    url: 'windows/start.js',
    backgroundColor: winDefaults.backgroundColor,
    barColor: winDefaults.barColor
});

var tab1 = Titanium.UI.createTab({
    icon: 'images/icons/home40.png',
    title: 'Начало',
    window: win1
});

//
// create controls tab and root window
//
var win2 = Titanium.UI.createWindow({
    navBarHidden: false,
    url: 'windows/movietab.js',
    backgroundColor: winDefaults.backgroundColor,
	barColor: winDefaults.barColor
});
var tab2 = Titanium.UI.createTab({
    icon: 'images/icons/video40.png',
    title: 'Фильмы',
    window: win2
});


var win3 = Titanium.UI.createWindow({
    url: 'windows/searchtab.js',
    navBarHidden: true,
    backgroundColor: winDefaults.backgroundColor
});

var tab3 = Titanium.UI.createTab({
    icon: 'images/icons/search40.png',
    title: 'Поиск',
    window: win3
});


var win4 = Titanium.UI.createWindow({
    navBarHidden: false,
    url: 'windows/mytab.js',
    backgroundColor: winDefaults.backgroundColor,
    barColor: winDefaults.barColor
});

var tab4 = Titanium.UI.createTab({
    icon: 'images/icons/favorite40.png',
    title: 'Кабинет',
    window: win4
});

var win5 = Titanium.UI.createWindow({
    title: 'Профиль',
    url: 'windows/profiletab.js',
    backgroundColor: winDefaults.backgroundColor,
    barColor: winDefaults.barColor
});

var tab5 = Titanium.UI.createTab({
    icon: 'images/icons/user40.png',
    title: 'Профиль',
    window: win5
});

//
//  add tabs
//
tabGroup.addTab(tab1);
tabGroup.addTab(tab2);
tabGroup.addTab(tab3);
tabGroup.addTab(tab4);
tabGroup.addTab(tab5);


// open tab group
tabGroup.open();

Titanium.UI.iPhone.statusBarStyle = Titanium.UI.iPhone.StatusBar.GRAY;






/**
 * Global operations
 */
function periodicStatusCheck(){
    //if (isLoggedIn()) {
        checkStatus();
    //}
    setTimeout(function(){
        periodicStatusCheck();
    }, 300000);
}

periodicStatusCheck();




/**
 * initial DB check
 */
if (unixtime() - DBLastConnect > DBLastConnect) {
    DBLastConnect = unixtime();
    reconnectDB();
}
db.execute("CREATE TABLE IF NOT EXISTS video(id integer,title_ru text,season_index integer,episode_index integer, videolink text,posterlink text,video_loaded integer,poster_loaded integer,start_time integer)");


function proceedInitialDl(){
	
    if (Titanium.App.Properties.getString("MOVIE_PATH") != "EXT") {
		
		
        var rootDir = Titanium.Filesystem.ApplicationDataDirectory;
		
		var movieDir = Titanium.Filesystem.getFile(rootDir, 'movies');
    }
    else {
		
        var rootDir = Titanium.Filesystem.externalStorageDirectory;
		
		var movieDir = Titanium.Filesystem.getFile(rootDir, 'horoshoTV.Data');
    }
    
	
	
    if (!movieDir.exists()) {
		Ti.API.info("creating directory:"+movieDir.nativePath);
        movieDir.createDirectory();
    }else{
		Ti.API.info("Directory exists:"+movieDir.nativePath);
	}
    //parse movie dir and films from DB , if some not loaded or not exists - delete it
}


/**
 * get root path for downloaded videos
 */
 /*
Titanium.App.Properties.setString("MOVIE_PATH","");
var root_path = Titanium.App.Properties.getString("MOVIE_PATH", "");
if (!root_path || root_path=="") {
	
    var resourceDir = Titanium.Filesystem.getFile(Titanium.Filesystem.applicationDataDirectory);
    Titanium.App.Properties.setString("MOVIE_PATH", "INT");
    if (Titanium.Filesystem.isExternalStoragePresent()) {
		Titanium.API.info("external storage present!");
      //  alert("external storage present!");
        //so we have external storage
        var extDir = Titanium.Filesystem.getFile(Titanium.Filesystem.externalStorageDirectory);
        var a = Titanium.UI.createAlertDialog({
            title: 'Выбор места хранения видео',
            message: 'Выберите, куда сохранять загружаемое видео:\n' +
            'A: встроенная память\n' +
            'B: карта памяти',
			buttonNames:['A', 'B']
        });
        
        a.addEventListener('click', function(e){
            try {
				Titanium.API.info("You choose:"+e.index);
				
				if (e.index == 1) {
					Titanium.App.Properties.setString("MOVIE_PATH", "EXT");
				}
				
				proceedInitialDl();
			}catch(e){
				alert("message"+e.message);
			}
        });
        
        a.buttonNames = ['A', 'B'];
        a.cancel = 0;
        a.show();
    }
    else {
        proceedInitialDl();
    }
    
    
}
else {
    proceedInitialDl();
}
*/








Titanium.App.addEventListener('onDownloadBegin', function(movieData){

	Ti.API.info("Begin download...");
    /*
     var info = '';
     for (var i in movieData) {
     info += i + '=' + movieData[i] + '\n';
     }
     info += 'dllink=' + playVideo;
     alert("app context:\n" + info);*/
    //check if we have already downloading process
    var state = Titanium.App.Properties.getString("IS_DOWNLOADING") * 1;
    if (state) {
        showWarning("Вы уже загружаете видео.");
        return;
    }
    
    //check if this movie is already loaded
    if (getEpisode(movieData['id'])) {
        showWarning("Эта серия уже есть в загрузках.");
        return;
    }
    Titanium.App.Properties.setString("IS_DOWNLOADING", "1");
    
    if (unixtime() - DBLastConnect > DBLastConnect) {
        DBLastConnect = unixtime();
        reconnectDB();
    }	
	var result=db.execute("INSERT INTO video(id,title_ru,season_index,episode_index,videolink,posterlink,video_loaded,poster_loaded,start_time) " +
    " VALUES(?,?,?,?,?,?,?,?,?)", movieData['id'], movieData['movie_title_ru'], movieData['season_index'], movieData['episode_index'], '', '', 0, 0, unixtime());
	var _arr =["INSERT INTO video(id,title_ru,season_index,episode_index,videolink,posterlink,video_loaded,poster_loaded,start_time) " +
    " VALUES(?,?,?,?,?,?,?,?,?)", movieData['id'], movieData['movie_title_ru'], movieData['season_index'], movieData['episode_index'], '', '', 0, 0, unixtime()];
	Ti.API.info("SQL:"+ _arr.toString());
	
	//Ti.API.info("DB INSERT:"+(result).toString());
	
	
    //next, download poster and show progress bar and download status in downloads page for the episode
    Ti.API.info("downloading image:"+'http://m.horosho.tv/f/episodes/mobile/' + movieData['image_id'] + '.jpg');
	fileDownload({
        destination: movieData['id'] + '.jpg',
        source: 'http://m.horosho.tv/f/episodes/mobile/' + movieData['image_id'] + '.jpg',
        callback: function(r){
            if (r) {
				
                db.execute("UPDATE video SET poster_loaded=1 WHERE id=?", movieData['id']);
                Ti.App.fireEvent('onDownloadInit');
                //start downloading video, set badge, add to downloads

				showInformer("Видео загружается");
                
				movieData['link'] = (movieData['link']).replace('play','download');
                fileDownload({
                    source: movieData['link'],
                    destination: movieData['id'] + '.mp4',
                    callback: function(r){
                        if (r) {
                            showWarning('Видео загружено!');
                            Titanium.App.Properties.setString("IS_DOWNLOADING", "0");
                            db.execute("UPDATE video SET video_loaded=1 WHERE id=?", movieData['id']);
                            Ti.App.fireEvent('onDownloadComplete');
                            
							if (isiOS4Plus()) {
								if (Titanium.App.Properties.getString("IS_BACKGROUNDED") != "0") {
									//show notification
									
									var notification = Ti.App.iOS.scheduleLocalNotification({
										alertBody: "Загрузка завершена",
										alertAction: "Открыть",
										userInfo: {
											"hello": "world"
										},
										date: new Date(new Date().getTime() + 1000) // 1 seconds after
									});
									
								}
								else 
									showInformer("Загрузка завершена");
							}else{
								showInformer("Загрузка завершена");
							}
                        }
                        else {
                            showWarning('Ошибка загрузки:\n' + arguments[1]);
                            cleanMovie(movieData['id']);
                            Titanium.App.Properties.setString("IS_DOWNLOADING", "0");
                        }
                    },
                    progress: function(p){
                        Ti.App.fireEvent('onDownloadProgress', {
                            progress: p
                        });
                    }
                    
                });
            }
            else {
                showWarning('Ошибка загрузки:\n' + arguments[1]);
                cleanMovie(movieData['id']);
                Titanium.App.Properties.setString("IS_DOWNLOADING", "0");
            }
            
        }
    });
    
});







function fileDownload(options){
    //source, destination, callback
    var source = options.source;
    var destination = options.destination;
    var callback = options.callback;
    var progress = options.progress || null;
    
    
    xmlHttpObj = Ti.Network.createHTTPClient();
    xmlHttpObj.onload = function(){
    
		Ti.API.info('fileDownload COMPLETE,response:'+xmlHttpObj.responseData.type);
		
        //only if Android...
        if (Ti.Platform.osname == 'android') {
            var movieDir = getDownloadDirectory();
			if(!movieDir){
				showWarning("Для загрузки вам необходимо вставить карту памяти!");
				callback(0);
			}
            if (xmlHttpObj.responseData.type == 1) {
                var f = Ti.Filesystem.getFile(xmlHttpObj.responseData.nativePath);
                
               
                var dest = Ti.Filesystem.getFile(movieDir.nativePath, destination);
				 Ti.API.info("Copying file from:" + xmlHttpObj.responseData.nativePath+"\n to:"+dest.nativePath);
                if (dest.exists) 
                    dest.deleteFile();
                f.move(dest.nativePath);
				Ti.API.info("Copying complete");
            }
            else {
			
				
                var f = Ti.Filesystem.getFile(movieDir.nativePath, destination);
                Ti.API.info("Writing to file from buffer... to"+f.nativePath);
				f.write(xmlHttpObj.responseData);
            }
        }
        
        
        callback(1);
    }
    
    xmlHttpObj.onerror = function(e){
        callback(0, e.error);
    };
    if (progress) {
    
        xmlHttpObj.ondatastream = function(e){
            progress(e.progress);
        };
    }
    
    // open the client
    if (Titanium.Platform.name == 'android') {
        xmlHttpObj.open('GET', source);
    }
    else {
        xmlHttpObj.open('GET', source);
        var movieDir = getDownloadDirectory();
        xmlHttpObj.file = Titanium.Filesystem.getFile(movieDir.nativePath, destination);
        
    }
    xmlHttpObj.send();
    
}







//initial setup
Titanium.App.Properties.setString("IS_DOWNLOADING", "0");

//delete unfinished videos
if (unixtime() - DBLastConnect > DBLastConnect) {
    DBLastConnect = unixtime();
    reconnectDB();
}

rows = db.execute("SELECT * FROM video");
while (rows.isValidRow()) {
    var e = parseEpisodeRow(rows);
    if (e.poster_loaded != 1 || e.video_loaded != 1) {
        cleanMovie(e.id);
    }
    rows.next();
}



Titanium.App.Properties.setString("IS_BACKGROUNDED", "0");

if (isiOS4Plus()) {

    var service = Ti.App.iOS.registerBackgroundService({
        url: 'bg.js'
    });
    
    Ti.App.addEventListener('resumed', function(e){
        var isBg = Titanium.App.Properties.getString("IS_BACKGROUNDED")*1;
		Titanium.App.Properties.setString("IS_BACKGROUNDED", "0");
		
		if(unixtime() - isBg < 30) return;
		
		
		//reload movies databases
		//reload subscribes/bookmarks/history
		//reload front page and recent
		
		
		Ti.App.fireEvent('onRefreshDB');
    });
    
}
