
var Ti = Titanium;


var winDefaults = {
    barColor: '#444',
    backgroundColor: '#EAEAEA'
};



var _loaderviews = [];
var _loaderviewsImages = [];
var _loaderCurrent = [];

var _imgChangeInterval = 80;
function attachLoader(parent, top, frametop){
    try {
		

        var animateOnStart = false;
        if (arguments.length == 4) {
            if (arguments[3] == 1) {
                animateOnStart = true;
                var initialTop =  -1020//(Titanium.Platform.osname == 'ipad') ? - 1020 : -460;
                var finishTop = top;
            }
        }
        var i = _loaderviews.length;
        parent.__loadviewIndex = i;
        
        
        var loaderView = Titanium.UI.createView({
            top: animateOnStart ? initialTop : top,
            height: 1020,  //(Titanium.Platform.osname == 'ipad') ? 1020 : 460,
            backgroundImage: '../images/loader/backpix.png'
        });
        
        
        
        parent.add(loaderView);
        
        if (animateOnStart) {
            //	alert('bagin animation, top:'+finishTop);
            var animation = Titanium.UI.createAnimation();
            animation.top = finishTop;
            animation.duration = 500;
            loaderView.animate(animation);
        }
    } 
    catch (e) {
 
    }
    
    var frame = Titanium.UI.createView({
        top: frametop,
        height: 190,
        width: 220,
        backgroundColor: '#fff',
        borderRadius: 25,
        borderColor: '#DDD',
        borderWidth: 3
    });
    loaderView.add(frame);
    var label = Titanium.UI.createLabel({
        text: 'Подождите',
        height: 'auto',
        width: 'auto',
        top: 160,
        color: '#666',
        font: {
            fontSize: 14
        },
        textAlign: 'center'
    });
    frame.add(label);
    _loaderviews.push(loaderView);
    
    _loaderviewsImages[i] = {};
    
    if (Ti.Platform.osname != 'android') {
		
		var images = [];
		
		for (var j = 1; j < 49; j++)
		{
			images.push('../images/loader/' + j + '.png');
		}
		
		var imageView = Titanium.UI.createImageView({
			images:images,
			duration:100, // in milliseconds, the time before next frame is shown
			repeatCount:0,  // 0 means animation repeats indefinitely, use > 1 to control repeat count
            width: 150,
            height: 141,
            opacity: 1,
            top: 10			
		});	
		 frame.add(imageView);
		/*
        for (var j = 1; j < 49; j++) {
            var image = Titanium.UI.createImageView({
                url: '../images/loader/' + j + '.png',
                width: 150,
                height: 141,
                opacity: 1,
                top: 10
            });
            frame.add(image);
            image.hide();
            _loaderviewsImages[i][j] = image;
            
        }*/
       // loaderView.currentImage = 1;
        //_loaderCurrent[i] = 1;
        
        /*setTimeout(function(){
            runLoader(i)
        }, _imgChangeInterval);
		*/
    }
    else {
    
        var image = Titanium.UI.createImageView({
            url: '../images/loader/1.png',
            width: 150,
            height: 141,
            top: 10
        });
        frame.add(image);
        
    }
	
}

function detachLoader(parent){
    if (_loaderviews[parent.__loadviewIndex]) {
        var animation = Titanium.UI.createAnimation();
        animation.top = 1020; //(Titanium.Platform.osname == 'ipad') ? 1020 : 460;
        animation.duration = 1000;
        
        animation.addEventListener('complete', function(){
            try {
				
				parent.remove(_loaderviews[parent.__loadviewIndex]);
            //    _loaderviews[parent.__loadviewIndex] = null;
            //    _loaderviewsImages[parent.__loadviewIndex] = null;
            } 
            catch (e) {
            
            }
        });
        _loaderviews[parent.__loadviewIndex].animate(animation);
        
        
    }
}

function runLoader(index){



    if (_loaderviews[index]) {
        var view = _loaderviews[index];
        var imgIndex = _loaderCurrent[index];
        var old = imgIndex;
        
        var nextIndex = (imgIndex * 1 < 48) ? imgIndex + 1 : 1;
        try {
            _loaderCurrent[index] = nextIndex;
            _loaderviewsImages[index][nextIndex].show();
            _loaderviewsImages[index][old].hide();
            
            
            setTimeout(function(){
                runLoader(index);
            }, _imgChangeInterval);
        } 
        catch (e) {
        
        }
    }
    
}


function jsonRequest(r){
    var url = r['url'] || null;
    var onsuccess = r['onSuccess'] ||
    function(){
    };
    var onerror = r['onError'] ||
    function(){
    };
    var method = r['method'] || 'GET';
    var data = r['data'] || {};
    
    if (!url) 
        return;
    
    var xhr = Titanium.Network.createHTTPClient();
    xhr.onload = function(){
    
        //	alert(this.responseText);
        
        try {
            var content = JSON.parse(this.responseText);
        } 
        catch (e) {
            onerror();
            return;
        }
        //	alert(onsuccess);
        onsuccess(content);
    }
    xhr.onerror = function(e){
        onerror(e);
    };
    xhr.open(method, "http://m.horosho.tv" + url);
    xhr.send(data);
    
}


function showPage(url){

	var title = 'HoroshoTV';
	if(arguments.length>1) title = arguments[1];
    
    var webWin = Titanium.UI.createWindow({
		title:title,
		/*,
		width:320,
		height:470
		*/
		navBarHidden: isAndroid() ? true : false,
		backgroundColor: winDefaults.backgroundColor,
		barColor: winDefaults.barColor		
    });
	winTop = 0;
	if(isAndroid()){
		var topView = Ti.UI.createView(
			{
				top:0,
				height:45,
				backgroundImage: '../images/headbg.png',
			}
		);
		
    var title = Ti.UI.createLabel({
        color: '#FFF',
        font: {
            fontSize: 20,
            fontWeight: 'normal',
            fontFamily: 'Arial'
        },
        shadowColor: '#222',
        shadowOffset: {
            x: 0,
            y: -1
        },
        top: 0,
        height: 45,
        text: 'HoroshoTV',
        width: 320,
        textAlign: 'center'
    });
    topView.add(title);		
		
	var button = Ti.UI.createButton({
		width:82,
		height:30,
		backgroundImage:'../images/back.png',
		backgroundSelectedImage: '../images/back_pressed.png',
		left:5,
		top:7
	});
	button.addEventListener('click',function(){
		webWin.close();
	});
	topView.add(button);
		webWin.add(topView);
	
		var winTop = 45;
	}
	
	/*
	var dm = [320,460];
    
	if (Titanium.Platform.osname == 'ipad') {
		dm = [760,1004];
	}

	var webViewHandler = Ti.UI.createView({
		width:(dm[0]-4),
		height:(dm[1]-4),
		borderRadius:5,
		borderWidth:3,
		borderColor:'#EAEAEA',
		opacity:0.5,
		top:5
	});
    webWin.add(webViewHandler);
	*/
	
	var webview = Ti.UI.createWebView({
		top: isAndroid() ? 45 : 0,
		loading:true
	});
	
	webview.url = url;
	
	webWin.add(webview);
	
	/*
	var button = Ti.UI.createButton({
		width:28,
		height:26,
		backgroundImage:'../images/close.png',
		left:0,
		top:0
	});
	button.addEventListener('click',function(){
		webWin.close();
	});
	webWin.add(button);
	
	*/	
    webWin.open();
    
}

function openMoviePage(movieId, movieTitle){

    var mWin = Titanium.UI.createWindow({
        url: 'movie.js',
        navBarHidden: false,
        backgroundColor: winDefaults.backgroundColor,
        barColor: winDefaults.barColor,
        movieId: movieId,
        movieTitle: movieTitle
    });
    
    
    if (!tab) {
        var tab = Titanium.UI.currentTab;
    }
    
    tab.open(mWin, {
        animated: true
    });
    
}

function playVideo(episodeId){
    jsonRequest({
        url: '/mobile/sencha/getdllink?v2=1&id=' + episodeId,
        onSuccess: function(r){
			
            if (r.result == 'success') {
                var playVideo = "http://m.horosho.tv" + r.link;
				Ti.API.info("DL LINK:"+r.link+" , session:"+r.sessid);
				Titanium.App.Properties.setString("SESSID",r.sessid);
                var playWin = Titanium.UI.createWindow({
                    url: 'play.js',
                    title: 'Просмотр',
                    barColor: winDefaults.barColor,
                    link: playVideo
                });
                
                playWin.open({
                    transition: Ti.UI.iPhone.AnimationStyle.FLIP_FROM_LEFT
                });
                /*if (!tab) {
                 var tab = Titanium.UI.currentTab;
                 }
                 
                 tab.open(playWin, {
                 animated: true
                 });
                 */
            }
            else {
                //show redirect web page...
            }
        }
        
    });
}


function unixtime(){
	return Math.round((new Date()).getTime() / 1000);

}
var db = null;
var DBHandlers;
var DBLastConnect = 0;
var DbReconnectInterval = 3600;
function openDB(){
	
	DBLastConnect = unixtime();
	try {
		db = Titanium.Database.open('horoshotv');
	}catch(e){
		alert("Не могу создать базу данных:"+e.message);
	}
}



function reconnectDB(){
	
	if(db)
		db.close();
	
	openDB();
}



function download(videoId){
	
    jsonRequest({
        url: '/mobile/sencha/getdllink?v2=1&id=' + videoId,
        onSuccess: function(r){
			Ti.API.info("DL LINK:"+r.link+" , session:"+r.sessid);
			Titanium.App.Properties.setString("SESSID",r.sessid);
			
            if (r.result == 'success') {
				var playVideo = "http://m.horosho.tv" + r.link;
					
				    jsonRequest({
						
						url: '/mobile/sencha/fullepisodedata?id='+videoId+'&purpose=download',
						onSuccess:function(movieData){
							Ti.API.info("downlad data:"+r.title_ru);
							if(movieData['access']!='allow'){
								showPage(movieData['redirect']);
								return;
							}
							
							movieData['link'] = playVideo;
							movieData['id'] = videoId;

							Ti.App.fireEvent('onDownloadBegin', movieData );
						}
					});
				
				
			}else{
				//show redirect web page
			}
		},onError:function(){
			showWarning('Нет соединения с сервером!');
		}
	});
	//mobile/sencha/fullepisodedata?id=	
}




function showWarning(message){
	Titanium.UI.createAlertDialog({title:'Внимание', message:message}).show();
}


function parseEpisodeRow(row){
    return {
        id: row.fieldByName('id'),
        title_ru: row.fieldByName('title_ru'),
        season_index: row.fieldByName('season_index'),
        episode_index: row.fieldByName('episode_index'),
        videolink: row.fieldByName('videolink'),
        posterlink: row.fieldByName('posterlink'),
        video_loaded: row.fieldByName('video_loaded'),
        poster_loaded: row.fieldByName('poster_loaded'),
        start_time: row.fieldByName('start_time')
    };
    
}

function getDownloadDirectory(){
	
	if(isAndroid() && !Titanium.Filesystem.isExternalStoragePresent()){
		return null;
	}
	if(isAndroid()){
        var rootDir = Titanium.Filesystem.externalStorageDirectory;
		var movieDir = Titanium.Filesystem.getFile(rootDir, 'horoshoTV.Data');		
	}else{
        var rootDir = Titanium.Filesystem.applicationDataDirectory;
		var movieDir = Titanium.Filesystem.getFile(rootDir, 'movies');	
	}
	
    if (!movieDir.exists()) {
		Ti.API.info("creating directory:"+movieDir.nativePath);
        movieDir.createDirectory();
    }else{
		Ti.API.info("Directory exists:"+movieDir.nativePath);
	}
    return movieDir;
}




function isIPhone3_2_Plus()
{
	// add iphone specific tests
	if (Titanium.Platform.name == 'iPhone OS')
	{
		var version = Titanium.Platform.version.split(".");
		var major = parseInt(version[0]);
		var minor = parseInt(version[1]);
		
		// can only test this support on a 3.2+ device
		if (major > 3 || (major == 3 && minor > 1))
		{
			return true;
		}
	}
	return false;
}

function isiOS4Plus()
{
	// add iphone specific tests
	if (Titanium.Platform.name == 'iPhone OS')
	{
		var version = Titanium.Platform.version.split(".");
		var major = parseInt(version[0]);
		
		// can only test this support on a 3.2+ device
		if (major >= 4)
		{
			return true;
		}
	}
	return false;
}

function isAndroid()
{
	if (Titanium.Platform.name != 'iPhone OS')
	{
		return true;
	}
	return false;
}


function showInformer(message){
	
		if(isAndroid()){
			showWarning(message);
			return;
		}
		var welcomeWindow = Titanium.UI.createWindow({
			height:80,
			width:200,
			touchEnabled:false
		});

		// black view
		var indView = Titanium.UI.createView({
			height:80,
			width:200,
			backgroundColor:'#000',
			borderRadius:10,
			opacity:0.7,
			touchEnabled:false
		});
		welcomeWindow.add(indView);

		// message
		var message = Titanium.UI.createLabel({
			text:message,
			color:'#fff',
			textAlign:'center',
			font:{fontSize:18,fontWeight:'bold'},
			height:'auto',
			width:'auto'
		});
		welcomeWindow.add(message);
		welcomeWindow.open();

		var animationProperties = {delay: 1500, duration: 1000, opacity: 0.1};
		if (Ti.Platform.osname == "iPhone OS") {
			animationProperties.transform =
				Ti.UI.create2DMatrix().translate(-200,200).scale(0);
		}
		welcomeWindow.animate(animationProperties, function()
		{
			welcomeWindow.close();
		});
			
}

function getEpisode(id){

    if (unixtime() - DBLastConnect > DBLastConnect) {
        DBLastConnect = unixtime();
        reconnectDB();
    }
    rows = db.execute("SELECT * FROM video WHERE id=?", id);
    count = rows.getRowCount();
    if (count != 1) {
        return null;
    }
    if (!rows.isValidRow()) {
        return null;
    }
    return parseEpisodeRow(rows);
}


function cleanMovie(id){

    ep = getEpisode(id);
    var movieDir = getDownloadDirectory();
	if(!movieDir){
		return;
	}
    var dest = Ti.Filesystem.getFile(movieDir.nativePath, id + ".mp4");
    if (dest.exists) 
        dest.deleteFile();
    
    var dest = Ti.Filesystem.getFile(movieDir.nativePath, id + ".jpg");
    if (dest.exists) 
        dest.deleteFile();
    
    //delete row from downloads table
    Ti.App.fireEvent('onDownloadError', {
        id: id
    });
    
    //delete badge if needed
    

    db.execute("DELETE FROM video WHERE id=?", id);
    
}


var bDimensions = isAndroid() ? [56,56] : [28,28];