

/**
 * 
 * @param {Object} movieItems
 * @return {Array}
 */
function drawMovieRows(movieItems){

	
	var useSection = false;
	if(arguments.length>1){
		var opts = arguments[1];
		useSection = opts.section || false;
	}
	
    var rows = [];
    
	var prevHdr = null;
    for (var i = 0; i < movieItems.length; i++) {
		
		var mItem = movieItems[i];
		
		var row = Ti.UI.createTableViewRow();
		
		row.tableClass = 'movieItems';
		
		if(useSection){
			var StrChar = (mItem[useSection]).charAt(0).toUpperCase();
			if(prevHdr!=StrChar){
				row.header = StrChar;
			}
			prevHdr = StrChar;
		}
		
		row.BackgroundColor = '#EAEAEA';
		
		//row.selectedBackgroundColor = '#EAEAEA';
		
		row.height = 82;
		
		row.movieId = mItem.id;
		row.movieTitle = mItem.title_ru;
		
		row.hasChild = true;
		
		var imgView = Ti.UI.createImageView({
			image: 'http://m.horosho.tv/f/movies/mobile/'+mItem.id+'.jpg',
			top: 1,
			left: 5,
			height: 80,
			width: 80
		});
		row.add(imgView);
		
		//discount
		var title = Ti.UI.createLabel({
			color: '#000',
			font: {
				fontSize: 16,
				fontWeight: 'normal',
				fontFamily: 'Arial'
			},
			left: 95,
			top: 2,
			height: 22,
			width: 200,
			text: mItem.title_ru
		});
		row.add(title);
		
		if (mItem.init_year) {
			var year = Ti.UI.createLabel({
				color: '#222',
				font: {
					fontSize: 12,
					fontWeight: 'normal',
					fontFamily: 'Arial'
				},
				left: 95,
				top: 24,
				height: 16,
				width: 200,
				text: "Год: " + mItem.init_year
			});
			row.add(year);
		}
		
		if (mItem.rating_imdb) {
			var imdb = Ti.UI.createLabel({
				color: '#222',
				font: {
					fontSize: 12,
					fontWeight: 'normal',
					fontFamily: 'Arial'
				},
				left: 95,
				top: 40,
				height: 16,
				width: 200,
				text: "Рейтинг: " + mItem.rating_imdb
			});
			row.add(imdb);
		}
		
		var stuff = Ti.UI.createLabel({
			color: '#222',
			font: {
				fontSize: 12,
				fontWeight: 'normal',
				fontFamily: 'Arial'
			},
			left: 95,
			top: 56,
			height: 24,
			width: 200,
			text: mItem.descr_ru
		});
		row.add(stuff);			
		
		rows.push(row);
	}
    
    return rows;
}
