

function isLoggedIn(){
    var uid = Titanium.App.Properties.getString("UID") * 1;
    return uid;
}

function attachLoginEvent(callback){

    Titanium.App.addEventListener('onProfileStateChanged', function(e){
    
        var uid = Titanium.App.Properties.getString("UID") * 1;
        if (uid) {
            callback(uid);
        }
        else {
            callback(false);
        }
        
    });
    
}


var authViews = [];

function getAuthView(options){

    var view = Ti.UI.createView({
        top: options.top || 0,
        opacity: options.opacity || 1,
        backgroundColor: '#EAEAEA'
    });
    
    var index = authViews.length;
    
	var ISAndroid = isAndroid();
    var labelLogin = Ti.UI.createLabel({
        color: '#000',
        font: {
            fontSize: 14,
            fontWeight: 'normal',
            fontFamily: 'Arial'
        },
        shadowColor: '#FAFAFA',
        shadowOffset: {
            x: 0,
            y: 1
        },
        top: 20,
        width: 300,
        textAlign: 'center',
        height: 'auto',
        text: 'Логин:'
    });
    view.add(labelLogin);
    
    var userLogin = Titanium.UI.createTextField({
        color: '#336699',
        value: '',
        height: ISAndroid ? 50 : 30,
        width: 250,
        top: 40,
      /*  borderStyle: Titanium.UI.INPUT_BORDERSTYLE_ROUNDED, */
        keyboardType: Titanium.UI.KEYBOARD_EMAIL
    });
    view.add(userLogin);
    
    
    
    var labelPass = Ti.UI.createLabel({
        color: '#000',
        font: {
            fontSize: 14,
            fontWeight: 'normal',
            fontFamily: 'Arial'
        },
        width: 250,
        textAlign: 'center',
        shadowColor: '#FFF',
        shadowOffset: {
            x: 0,
            y: 1
        },
        top:  isAndroid() ? 103 : 83,
        height: 'auto',
        text: 'Пароль:'
    });
    view.add(labelPass);
    
    var userPassword = Titanium.UI.createTextField({
        color: '#336699',
		passwordMask:true,
        value: '',
        height: ISAndroid ? 50 : 30,
        width: 250,
        top: ISAndroid ? 125 : 105,
        borderStyle: Titanium.UI.INPUT_BORDERSTYLE_ROUNDED,
        keyboardType: Titanium.UI.KEYBOARD_ASCII
    });
    view.add(userPassword);
    authViews.push({
        userLogin: userLogin,
        userPass: userPassword
    });
    
    var labelForgot = Ti.UI.createLabel({
        color: '#000',
        font: {
            fontSize: 14,
            fontWeight: 'normal',
            fontFamily: 'Arial'
        },
        width: 250,
        textAlign: 'center',
        shadowColor: '#FFF',
        shadowOffset: {
            x: 0,
            y: 1
        },
        top: ISAndroid ? 180 :140,
        height: 'auto',
        text: 'Забыли пароль?'
    });
    view.add(labelForgot);
    
    labelForgot.addEventListener('click', function(){
        //open forgot web page
        
		try {
			showPage('http://m.horosho.tv/mobile/sencha/forgot');
		}catch(e){
			alert(e.message);
		}
 
    });
    
    var lfUnderline = Ti.UI.createView({
        top: ISAndroid ? 196 : 156,
        width: 108,
        height: 1,
        backgroundColor: '#000'
    });
    view.add(lfUnderline);
    
    var Button = Titanium.UI.createButton({
        backgroundImage: '../images/login.png',
		backgroundSelectedImage:'../images/login_pressed.png',
        width: 250,
        height: 41,
        top: ISAndroid ? 220 : 180,
        viewIndex: index
    });
    view.add(Button);
    
    Button.addEventListener('click', function(e){
        //
        if (typeof e.source.viewIndex != 'undefined') {
            var login = authViews[e.source.viewIndex].userLogin.value;
            var pass = authViews[e.source.viewIndex].userPass.value;
            
			
            if (!login || !pass) {
                Titanium.UI.createAlertDialog({
                    title: 'Внимание',
                    message: 'Логин и пароль не должны быть пусты!'
                }).show();
                return;
            }
			authViews[e.source.viewIndex].userLogin.blur();
            authViews[e.source.viewIndex].userPass.blur();
            tryLogin(login, pass);
        }
    });
    
    var Button2 = Titanium.UI.createButton({
        backgroundImage: '../images/register.png',
        width: 250,
        height: 41,
        top: ISAndroid ? 280 : 240
    });
    view.add(Button2);
    
    Button2.addEventListener('click', function(e){
        showPage('http://m.horosho.tv/mobile/sencha/regform');
    });
    
    return view;
}

function tryLogin(login, pass){

    jsonRequest({
        url: '/mobile/sencha/checkauth',
		method:'POST',
        onSuccess: function(r){
        	if(r.result=='success'){
				Titanium.App.Properties.setString("SESSION_TOKEN",r.session_token);
				
				//second request to pass our info
				checkStatus();
				
			}else{
                Titanium.UI.createAlertDialog({
                    title: 'Внимание',
                    message: 'Логин или пароль не верны!'
                }).show();
			}
        },
        data: {
            system_login: login,
            system_pass: pass,
            ajax: 1
        }
    
    });
}


function checkStatus(){
				var r = {};
				r['version'] = '1.2';
				r['uuid'] = Titanium.Platform.id;
				r['device_version'] = Titanium.Platform.version;
				r['model'] = Titanium.Platform.osname;
				 jsonRequest({
				 		method:'GET',
						url: '/mobile/sencha/checkauth',
						onSuccess: function(result){
						   if('banner' in result){
	                       		showPage(result['banner']);
	                       }
						   Titanium.App.Properties.setString("SESSID",result['sessid']);
						   if (result['uid']) {
						   		
						   		if(isLoggedIn()){
									return;
								}else{
									Titanium.App.Properties.setString("UID",result['uid']);
									Titanium.App.fireEvent('onProfileStateChanged');
								}
								
						   }else{
						   		if (!isLoggedIn()) {
									return;
								}
								else {
									
									Titanium.App.Properties.setString("UID", "0");
									Titanium.App.fireEvent('onProfileStateChanged');
								}							
						   }
						   
						},
						data:r
				});	
}




