Titanium.include("../lib/defaults.js", "../lib/profile.js", "../lib/movielist.js");

var win = Titanium.UI.currentWindow;



var tab = Titanium.UI.currentTab;

win.title = ' Сериал';

var movie_id = win.movieId;
var movie_title = win.movieTitle;

var isSubscribedSwitch, isBookmarkedSwitch;
/**
 * Load movie info... and then append it to the movie
 */
//'mobile/sencha/movie'



var scrollView = Titanium.UI.createScrollView({
    contentWidth: 'auto',
    contentHeight: 'auto',
    top: 0,
    backgroundColor: winDefaults.backgroundColor,
    showVerticalScrollIndicator: true,
    showHorizontalScrollIndicator: true,
    layout: 'vertical'
});
win.add(scrollView);
attachLoader(win, 0, 100);

var viewWidth = 300;
if(isAndroid()){
	var _width = Titanium.Platform.displayCaps.platformWidth;
	if(_width>320){
		viewWidth = _width - 20;
	}
}else{
	if(Titanium.Platform.osname == 'ipad') viewWidth = 700;
}

var view = Ti.UI.createView({
    backgroundColor: 'white',
    borderRadius: 5,
    width:  viewWidth ,
    top: 10,
    height: 'auto'
});
scrollView.add(view);

var spacer = Ti.UI.createView({
    backgroundColor: winDefaults.backgroundColor,
    height: 10
});
scrollView.add(spacer);






jsonRequest({
    url: '/mobile/sencha/movie?movie=' + movie_id,
    onSuccess: function(movie){
    
    
        var genres = Ti.UI.createLabel({
            color: '#222',
            font: {
                fontSize: 12,
                fontWeight: 'normal',
                fontFamily: 'Arial'
            },
            left: _imgDimensions[0]+5,
            top: 25,
            height: 16,
            width: 210,
            text: "Жанр: " + movie.genres
        });
        view.add(genres);
        
        if (movie.init_year) {
            var year = Ti.UI.createLabel({
                color: '#222',
                font: {
                    fontSize: 12,
                    fontWeight: 'normal',
                    fontFamily: 'Arial'
                },
                left: _imgDimensions[0]+5,
                top: 41,
                height: 16,
                width: 210,
                text: "Год: " + movie.init_year + " - " + movie.finish_year
            });
            view.add(year);
        }
        if (movie.rating_imdb) {
            var rating = Ti.UI.createLabel({
                color: '#222',
                font: {
                    fontSize: 12,
                    fontWeight: 'normal',
                    fontFamily: 'Arial'
                },
                left: _imgDimensions[0]+5,
                top: 57,
                height: 16,
                width: 210,
                text: "IMDB  рейтинг: " + movie.rating_imdb + "/10"
            });
            view.add(rating);
        }
        
        /**
         * Titanium.UI.createButton
         */
        var Button = Titanium.UI.createButton({
            backgroundImage: '../images/viewyellow.png',
			backgroundSelectedImage: '../images/viewyellow_pressed.png',
            width: 278,
            height: 46,
            top: _contentTop
        });
        view.add(Button);
        
        Button.addEventListener('click', function(e){
        
        
            var sWin = Titanium.UI.createWindow({
                url: 'movieseasons.js',
                backgroundColor: winDefaults.backgroundColor,
                barColor: winDefaults.barColor,
                movieId: movie.id,
                seasons: movie.seasons
            });
            
            
            tab.open(sWin, {
                animated: true
            });
            
        });
        
        
        var descr = Ti.UI.createLabel({
            color: '#222',
            font: {
                fontSize: 12,
                fontWeight: 'normal',
                fontFamily: 'Arial'
            },
            left: 5,
            top: 145+_contentTop,
            height: 'auto',
            text: movie.descr_ru + '\n   '
        });
        
        view.add(descr);
        try {
            var switchView = Titanium.UI.createView({
                width: 278,
                borderRadius: 10,
                borderWidth: 2,
                borderColor: '#CACACA',
                top: 50 + _contentTop,
                height: 92,
                backgroundColor: '#EAEAEA'
            });
            view.add(switchView);
            
            isBookmarkedSwitch = Titanium.UI.createSwitch({
                value: false,
                top: isAndroid() ? 4 : 10,
                right: 10,
				height:40
            });
			
            isBookmarkedSwitch.addEventListener('change', function(e){
                if (isLoggedIn()) {
					if (e.value) {
					//subscr
						jsonRequest({
							url: '/mobile/sencha/addbookmarkitem?bk_id=' + movie_id+'&bk_type=movie',
							onSuccess: function(res){}
						});					
					}
					else {
						//unsubscr
						jsonRequest({
							url: '/mobile/sencha/removebookmarkitem?movie_id=' + movie_id,
							onSuccess: function(res){}
						});
					}
				}
                
            });
						
            
            if (!isLoggedIn()) {
                isBookmarkedSwitch.enabled = false;
                isBookmarkedSwitch.value = false;
            }else{
				
				isBookmarkedSwitch.value = (movie.user_data.bookmarked==1) ? true : false;

				
			}
            var BkLabel = Ti.UI.createLabel({
                color: '#222',
                font: {
                    fontSize: 18,
                    fontWeight: 'normal',
                    fontFamily: 'Arial'
                },
                shadowColor: '#FAFAFA',
                shadowOffset: {
                    x: 0,
                    y: 1
                },
                left: 10,
                top: 12,
                height: 'auto',
                text: 'В закладки'
            });
            
            var dView = Titanium.UI.createView({
                height: 2,
                backgroundColor: '#CACACA',
                top: 45
            });
            switchView.add(dView);
            switchView.add(BkLabel);
            switchView.add(isBookmarkedSwitch);
            isSubscribedSwitch = Titanium.UI.createSwitch({
                value: false,
                top: isAndroid() ? 49 : 57,
                right: 10,
				height:40
            });
            
            isSubscribedSwitch.addEventListener('change', function(e){
                if (isLoggedIn()) {
					if (e.value) {
					//subscr
						jsonRequest({
							url: '/mobile/sencha/addsubscribeitem?movie=' + movie_id,
							onSuccess: function(res){}
						});					
					}
					else {
						//unsubscr
						jsonRequest({
							url: '/mobile/sencha/removesubscribeitem?movie=' + movie_id,
							onSuccess: function(res){}
						});
					}
				}
                
            });
            
            if (!isLoggedIn()) {
                isSubscribedSwitch.enabled = false;
                isSubscribedSwitch.value = false;
            }else{
				
				isSubscribedSwitch.value = (movie.user_data.subscribed==1) ? true : false;

				
			}
            
            var SsLabel = Ti.UI.createLabel({
                color: '#222',
                font: {
                    fontSize: 18,
                    fontWeight: 'normal',
                    fontFamily: 'Arial'
                },
                shadowColor: '#FAFAFA',
                shadowOffset: {
                    x: 0,
                    y: 1
                },
                left: 10,
                top: 59,
                height: 'auto',
                text: 'Подписаться'
            });
            switchView.add(SsLabel);
            switchView.add(isSubscribedSwitch);
        } 
        catch (e) {
            alert(e.message);
        }
        
        attachLoginEvent(function(uid){
            if (uid) {
                isSubscribedSwitch.enabled = true;
                isBookmarkedSwitch.enabled = true;
            }
            else {
                isSubscribedSwitch.enabled = false;
                isBookmarkedSwitch.enabled = false;
                isSubscribedSwitch.value = false;
                isBookmarkedSwitch.value = false;
            }
        });
        
        var actors = '';
        for (var i in movie.actors) {
            if (typeof movie.actors[i]['id'] == 'undefined') 
                continue;
            actors += '<div style="float:none;clear:both;height:48px;font-size:12px">' +
            '<img style="float:left;" src="' +
            'http://m.horosho.tv/f/actors/small/' +
            movie.actors[i]['id'] +
            '.jpg" border=0/>' +
            '<div style="margin-left:45px;padding-top:10px;"><b>' +
            movie.actors[i]['title_en'] +
            '</b> - <i>' +
            movie.actors[i]['character'] +
            '</i></div>' +
            '</div>';
        }
        
        
        var view2 = Titanium.UI.createWebView({
            backgroundColor: 'white',
            borderRadius: 5,
            width: viewWidth,
            height: 'auto',
            touchEnabled: false,
            html: '<html><head><style>body{margin:5px}*{font-size:12px;font-family:Arial;}</style></head><body><b style="font-size:14px">Актерский состав:</b>' + actors + '</body>'
        });
        
        scrollView.add(view2);
        
        detachLoader(win);
        
    }
});
if (Titanium.Platform.osname == 'ipad' || viewWidth > 600){
	var _imgPath = 'http://m.horosho.tv/f/movies/big/' + movie_id + '.jpg'
	var _imgDimensions = [300,166];
}else{
	var _imgPath = 'http://m.horosho.tv/f/movies/mobile/' + movie_id + '.jpg';
	var _imgDimensions = [80,80];
}
var _contentTop = _imgDimensions[1]+10;

var imgView = Ti.UI.createImageView({
    image: _imgPath,
    top: 0,
    left: 0,
    height: _imgDimensions[1],
    width: _imgDimensions[0]
});
view.add(imgView);

var title = Ti.UI.createLabel({
    color: '#000',
    font: {
        fontSize: 18,
        fontWeight: 'normal',
        fontFamily: 'Arial'
    },
    left: _imgDimensions[0]+5,
    top: 5,
    height: 20,
    width: 210,
    text: movie_title
});
view.add(title);







