
Titanium.include("../lib/defaults.js", "../lib/profile.js", "../lib/movielist.js");

var win = Titanium.UI.currentWindow;



var tab = Titanium.UI.currentTab;

Titanium.App.addEventListener('onRefreshDB', function(movie){
	refreshMovieDB();
});

if (Titanium.Platform.name == 'iPhone OS') {
    var bb1 = Titanium.UI.createTabbedBar({
        labels: ['По жанру', 'По рейтингу', 'По алфавиту'],
        top: 0,
        index: 0,
        style: Titanium.UI.iPhone.SystemButtonStyle.BAR,
        backgroundColor: '#444',
    });
    win.setTitleControl(bb1);
    
    bb1.addEventListener('click', function(e){
    
        var index = e.index;
        if (currentActiveItem == index) {
            return;
        }
        views[currentActiveItem].hide();
        currentActiveItem = index;
        
        views[currentActiveItem].show();
    });
}
else {

	
    var toolbar = Titanium.UI.createView({
        
        height: 44,
        top: 0,
		width:281
    
    });
	
	var TBHandler = Titanium.UI.createView({
		backgroundImage: '../images/cabsplit2/bg.png',	
        height: 44,
        top: 0
    });
    
    win.add(TBHandler);
    TBHandler.add(toolbar);

	
    
    
    
    var tbButtons = [];
    
    
    
    
    tbButtons[0] = Titanium.UI.createButton({
        left: 0, // -20
        height: 30,
        top: 7,
        backgroundImage: '../images/splitbtn/by_genre_active2.png',
        backgroundSelectedImage: '../images/splitbtn/by_genre_active2.png',
        width: 94
    });
    
    tbButtons[0].addEventListener('click', function(e){
    
        setActive(0);
    });
    
    toolbar.add(tbButtons[0]);
    
    tbButtons[1] = Titanium.UI.createButton({
        left: 94, //-20
        height: 30,
        top: 7,
        backgroundImage: '../images/splitbtn/by_rating2.png',
        backgroundSelectedImage: '../images/splitbtn/by_rating_active2.png',
        width: 94
    });
    
    tbButtons[1].addEventListener('click', function(e){
        setActive(1);
        
    });
    
    toolbar.add(tbButtons[1]);
    
    
    tbButtons[2] = Titanium.UI.createButton({
        left: 188, //-20
        height: 30,
        top: 7,
        backgroundImage: '../images/splitbtn/by_alpha2.png',
        backgroundSelectedImage: '../images/splitbtn/by_alpha_active2.png',
        width: 93
    });
    
    tbButtons[2].addEventListener('click', function(e){
        setActive(2);
    });
    
    toolbar.add(tbButtons[2]);
    
}


var views = [];

var currentActiveItem = 0;



function setActive(index){
    if (currentActiveItem == index) {
        return;
    }
    views[currentActiveItem].hide();
    currentActiveItem = index;
    if (currentActiveItem == 0) {
        tbButtons[0].backgroundImage = '../images/splitbtn/by_genre_active2.png';
    }
    else {
        tbButtons[0].backgroundImage = '../images/splitbtn/by_genre2.png';
    }
    
    if (currentActiveItem == 1) {
        tbButtons[1].backgroundImage = '../images/splitbtn/by_rating_active2.png';
    }
    else {
        tbButtons[1].backgroundImage = '../images/splitbtn/by_rating2.png';
    }
    
    if (currentActiveItem == 2) {
        tbButtons[2].backgroundImage = '../images/splitbtn/by_alpha_active2.png';
    }
    else {
        tbButtons[2].backgroundImage = '../images/splitbtn/by_alpha2.png';
    }
    
    
    views[currentActiveItem].show();
}




var bodyTop = (Titanium.Platform.name == 'iPhone OS') ? 0 : 44;
/**
 * VIEWS
 */
views[0] = Titanium.UI.createTableView({
    top: bodyTop,
    backgroundColor: winDefaults.backgroundColor,
    data: []
});
views[0].addEventListener('click', function(e){
    if (e.rowData.genre) {
    
        //show genre-list event
        var gwin = Titanium.UI.createWindow({
            title: e.rowData.genre_title,
            url: 'genre.js',
            navBarHidden: false,
            backgroundColor: winDefaults.backgroundColor,
            barColor: winDefaults.barColor,
            genre: e.rowData.genre
        });
        //	gwin.genre = e.rowData.genre;
        //	gwin.open();
        
        
        tab.open(gwin, {
            animated: true
        });
        
    }
});

/**
 * By ragint, make ajax then draw
 */
views[1] = Titanium.UI.createTableView({
    top: bodyTop,
    backgroundColor: winDefaults.backgroundColor
});

views[1].addEventListener('click', function(e){
    if (e.rowData.movieId) {
        openMoviePage(e.rowData.movieId, e.rowData.movieTitle);
    }
});




views[2] = Titanium.UI.createTableView({
    top: bodyTop,
    backgroundColor: winDefaults.backgroundColor
});
views[2].addEventListener('click', function(e){
    if (e.rowData.movieId) {
        openMoviePage(e.rowData.movieId, e.rowData.movieTitle);
    }
});

views[1].hide();
views[2].hide();
win.add(views[1]);
win.add(views[2]);
win.add(views[0]);


var all;
function onOneLoaded(){
    all++;
    if (all == 3) {
        setTimeout(function(){
            detachLoader(win);
        }, 2000);
    }
}





function refreshMovieDB(){
	attachLoader(win, bodyTop, 60);
	
	all = 0;
    /**
     * Genres
     */
    //mobile/sencha/bygenre
    jsonRequest({
        url: '/mobile/sencha/bygenre',
        onSuccess: function(response){
        
            var content = response.rows;
            var rows = [];
            for (var i = 0; i < content.length; i++) {
                var genre = content[i];
                var row = Ti.UI.createTableViewRow({
                    BackgroundColor: '#EAEAEA',
                    height: 60,
                    genre: genre.name_en,
                    genre_title: genre.title_ru
                });
                row.tableClass = 'movieGenres';
                
                var title = Ti.UI.createLabel({
                    color: '#000',
                    font: {
                        fontSize: 16,
                        fontWeight: 'normal',
                        fontFamily: 'Arial'
                    },
                    left: 5,
                    top: 2,
                    height: 21,
                    width: 260,
                    text: genre.title_ru
                });
                row.add(title);
                var descr = Ti.UI.createLabel({
                    color: '#000',
                    font: {
                        fontSize: 12,
                        fontWeight: 'normal',
                        fontFamily: 'Arial'
                    },
                    left: 5,
                    top: 26,
                    height: 32,
                    width: 260,
                    text: genre.movies_count + ": " + genre.movies_text
                });
                row.add(descr);
                rows.push(row);
            }
            views[0].setData(rows);
            onOneLoaded();
        },
        onError: function(){
			onOneLoaded();
        }
    });
    
    
    /**
     * By rating
     */
    jsonRequest({
        url: '/mobile/sencha/byrating',
        onSuccess: function(response){
        
            var content = response.rows;
            var _rows = drawMovieRows(content);
            views[1].setData(_rows);
            onOneLoaded();
        },
        onError: function(){
			onOneLoaded();
        }
    });
    
    
    /**
     * by Alpha
     */
    jsonRequest({
        url: '/mobile/sencha/alpha',
        onSuccess: function(response){
        
            var content = response.rows;
            var _rows = drawMovieRows(content, {
                'section': 'title_ru'
            });
            views[2].setData(_rows);
            onOneLoaded();
        },
        onError: function(){
			onOneLoaded();
        }
    });
    
}

refreshMovieDB();











