
Titanium.include("../lib/defaults.js", "../lib/profile.js", "../lib/movielist.js");

var win = Titanium.UI.currentWindow;

var tab = Titanium.UI.currentTab;


Titanium.App.addEventListener('onRefreshDB', function(movie){
	refreshMyDB();
});


function refreshMyDB(){
	if (isLoggedIn()) {
		loadHistory();
		loadBookmarks();
		loadSubscribes();
	}
}

if (Titanium.Platform.name == 'iPhone OS') {
    var bb1 = Titanium.UI.createTabbedBar({
        labels: ['История', 'Закладки', 'Подписки', 'Загрузки'],
        top: 0,
		index:0,
        style: Titanium.UI.iPhone.SystemButtonStyle.BAR,
        backgroundColor: '#444',
    });
    win.setTitleControl(bb1);
    
    bb1.addEventListener('click', function(e){
    
        var index = e.index;
        if (currentActiveItem == index) {
            return;
        }
        views[currentActiveItem].hide();
        currentActiveItem = index;
        
        views[currentActiveItem].show();
    });
}
else {



    var toolbar = Titanium.UI.createView({
        
        height: 44,
        top: 0,
		width:299
    
    });
	
	var TBHandler = Titanium.UI.createView({
		backgroundImage: '../images/cabsplit2/bg.png',	
        height: 44,
        top: 0
    });
    
    win.add(TBHandler);
    TBHandler.add(toolbar);
    
    
    var tbButtons = [];
    
    
    
    
    tbButtons[0] = Titanium.UI.createButton({
        left: 0, //-12
        height: 30,
        top: 7,
        backgroundImage: '../images/cabsplit2/history_p.png',
        backgroundSelectedImage: '../images/cabsplit2/history_p.png',
        width: 75
    });
    
    tbButtons[0].addEventListener('click', function(e){
        setActive(0);
    });
    
    toolbar.add(tbButtons[0]);
    
    tbButtons[1] = Titanium.UI.createButton({
        left: 75, //-12
        height: 30,
        top: 7,
        backgroundImage: '../images/cabsplit2/bk.png',
        backgroundSelectedImage: '../images/cabsplit2/bk_p.png',
        width: 75
    });
    
    tbButtons[1].addEventListener('click', function(e){
        setActive(1);
        
    });
    
    toolbar.add(tbButtons[1]);
    
    
    tbButtons[2] = Titanium.UI.createButton({
        left: 150, //-12
        height: 30,
        top: 7,
        backgroundImage: '../images/cabsplit2/sc.png',
        backgroundSelectedImage: '../images/cabsplit2/sc_p.png',
        width: 75
    });
    
    tbButtons[2].addEventListener('click', function(e){
        setActive(2);
    });
    
    toolbar.add(tbButtons[2]);
    
    
    tbButtons[3] = Titanium.UI.createButton({
        left: 225, //-12
        height: 30,
        top: 7,
        backgroundImage: '../images/cabsplit2/dl.png',
        backgroundSelectedImage: '../images/cabsplit2/dl_p.png',
        width: 74
    });
    
    tbButtons[3].addEventListener('click', function(e){
        setActive(3);
    });
    
    toolbar.add(tbButtons[3]);
    
}
var views = [];

var currentActiveItem = 0;



function setActive(index){
    if (currentActiveItem == index) {
        return;
    }
    views[currentActiveItem].hide();
    currentActiveItem = index;
    if (currentActiveItem == 0) {
        tbButtons[0].backgroundImage = '../images/cabsplit2/history_p.png';
    }
    else {
        tbButtons[0].backgroundImage = '../images/cabsplit2/history.png';
    }
    
    if (currentActiveItem == 1) {
        tbButtons[1].backgroundImage = '../images/cabsplit2/bk_p.png';
    }
    else {
        tbButtons[1].backgroundImage = '../images/cabsplit2/bk.png';
    }
    
    if (currentActiveItem == 2) {
        tbButtons[2].backgroundImage = '../images/cabsplit2/sc_p.png';
    }
    else {
        tbButtons[2].backgroundImage = '../images/cabsplit2/sc.png';
    }
    
    if (currentActiveItem == 3) {
        tbButtons[3].backgroundImage = '../images/cabsplit2/dl_p.png';
    }
    else {
        tbButtons[3].backgroundImage = '../images/cabsplit2/dl.png';
    }
    
    
    views[currentActiveItem].show();
	
	/*
	if(currentActiveItem==1){
		//bks and it is android
		for(var i=0;i<bkDelButtons.length;i++){
			
			if(bkManageState){
				bkDelButtons[i].show();
			}else{
				bkDelButtons[i].hide();
			}
		}
	}
	*/
}



var viewsLoaded = false;


var bodyTop = (Titanium.Platform.name == 'iPhone OS') ? 0 : 44;

views[0] = Titanium.UI.createTableView({
    top: bodyTop,
    backgroundColor: winDefaults.backgroundColor,
    data: []
});

/**
 * Subscribes block
 */
Ti.include('../views/history.js');




views[1] = Titanium.UI.createView({
    top: bodyTop
});


var Tb0 = Titanium.UI.createTableView({
    top: 0, //6+1 - was 37
    backgroundColor: winDefaults.backgroundColor,
    data: []
});

Tb0.addEventListener('click', function(e){
    if (e.rowData.movie_id) {
        openMoviePage(e.rowData.movie_id, e.rowData.movieTitle);
    }
});

Tb0.addEventListener('delete', function(e){
    if (e.row.bkId) {
        //mobile/sencha/removebookmarkitem?bk_id=
        
        jsonRequest({
            url: '/mobile/sencha/removebookmarkitem?bk_id=' + e.row.bkId,
            onSuccess: function(res){
            }
        });
    }
    
});

views[1].add(Tb0);


var Back01 = Titanium.UI.createView({
    backgroundImage: '../images/edit_topbg.png',
    top: 0,
    height: 2,
    right: 83
});
var Back0 = Titanium.UI.createView({
    backgroundImage: '../images/edit_bg.png',
    top: 0,
    height: 34,
    right: 0,
    width: 83
});

var Edit0 = Titanium.UI.createButton({
    backgroundImage: '../images/change.png',
    width: 74,
    height: 30,
    top: 2,
    right: 3

});
Edit0.addEventListener('click', function(){
    Tb0.editing = true;
	if(isAndroid()){
		for(var i=0;i<bkDelButtons.length;i++)
			bkDelButtons[i].show();
		bkManageState = true;
	} 
    Edit0_1.show();
    Edit0.hide();
});

Back0.add(Edit0);

var Edit0_1 = Titanium.UI.createButton({
    backgroundImage: '../images/cancelchange.png',
    width: 74,
    height: 30,
    top: 2,
    right: 3

});
Edit0_1.addEventListener('click', function(){
    Tb0.editing = false;
	if(isAndroid()){
		for(var i=0;i<bkDelButtons.length;i++)
			bkDelButtons[i].hide();
		bkManageState = false;
	} 
    Edit0_1.hide();
    Edit0.show();
});
Edit0_1.hide();
Back0.add(Edit0);
Back0.add(Edit0_1);

views[1].add(Back0);
views[1].add(Back01);


/**
 * Subscribes block
 */
views[2] = Titanium.UI.createView({
    top: bodyTop
});

Ti.include('../views/subscribes.js');




views[3] = Titanium.UI.createView({
    top: bodyTop
});



/**
 * Subscribes block
 */
Ti.include('../views/downloads.js');



var authView = getAuthView({
    top: bodyTop
});


views[1].hide();
views[2].hide();
views[3].hide();
win.add(views[0]);
win.add(views[1]);
win.add(views[2]);


var bookmarks = [];

function loadMyData(){
    //load subscr/history/bookmarks
    loadBookmarks();
    
    loadSubscribes();
}

var bkManageState = false;
var bkDelButtons = [];
function loadBookmarks(){
    //mobile/sencha/bookmarks
    
    jsonRequest({
        url: '/mobile/sencha/bookmarks?v2=1',
        onSuccess: function(res){
            bookmarks = res.rows;
            for (var i = 0; i < bookmarks.length; i++) {
                bookmarks[i].title_ru = bookmarks[i].title;
                bookmarks[i].descr_ru = bookmarks[i].description;
				bookmarks[i].id = bookmarks[i].movie_id;
            }
			

						
            var rows = drawMovieRows(bookmarks);
            for (var i = 0; i < rows.length; i++) {
                rows[i].movie_id = bookmarks[i].movie_id;
                rows[i].bkId = bookmarks[i].id;
				
				
				if(isAndroid()){
					var delButton =  Ti.UI.createButton({
							height: 30,
							bottom: 10,
							backgroundImage: '../images/delete.png',
							backgroundSelectedImage: '../images/delete_pressed.png',
							text:'Delete',
							width: 50,
							visible:bkManageState,
							bkId:rows[i].bkId
					});
					
					rows[i].add(delButton);
					
					/*
					if(!bkManageState){
						delButton.hide();
					}*/
					
					delButton.addEventListener('click',function(e){
									
						jsonRequest({
							url: '/mobile/sencha/removebookmarkitem?bk_id=' + e.source.bkId,
							onSuccess: function(res){
								//refresh bk table with state == 1
								loadBookmarks();
							}
						});
						//reload local movies...
					});
					bkDelButtons.push(delButton);
				}				
            }
            
            Tb0.setData(rows);
        }
    });
}





if (isLoggedIn()) {
    authView.hide();
    if (!viewsLoaded) {
        loadMyData();
        viewsLoaded = true;
    }
}

win.add(authView);
win.add(views[3]);



attachLoginEvent(function(uid){
    if (uid) {
        authView.hide();
        
        if (!viewsLoaded) {
            loadMyData();
            loadHistory();
            viewsLoaded = true;
        }
        
    }
    else {
        authView.show();
        viewsLoaded = false;
        
    }
});






